/********************************************************************************************************/
/*
 Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier FrÈdÈric (University of Science and Technology of Nantes)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Contact: glovecontrol@free.fr
 */
/********************************************************************************************************/
//
#ifndef CONTROLLER_H
#define CONTROLLER_H
//
// Librairies QT
#include <QThread>
#include <QMutex>
#include <QTest>
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
// Librairies STL
#include <iostream>
#include <algorithm>
// Librairies Zor
#include "../Zor/Tools.h"
#include "../GC/Tools.h"
#include <QTest>
#include <QTimer>
//
namespace AAC { class Controller; }
#include "EE/Etat.h"
#include "Analyzer.h"
//
namespace AAC {
//
class Controller :  public QThread {
	//
	Q_OBJECT
	//

protected :
	EE::Etat * _state ; // pattern State

public:





	Controller(Analyzer * analyzer) ;
	virtual ~Controller() ;
    void run();
	//Modifie l'état
	//void setState(Etat *) ;
	void handle_case() ;
	void recuperePoints() ;
    //
	void setState(Zor::Tools::ETAT_WEBCAM etat);
    inline QVector<CvPoint> getListePoints() { return _ListePoints; }
    inline double getRayonDroit() { return _RayonDroit; }
    inline double getRayonGauche() { return _RayonGauche; }
    //
private:
    //
    double _Rayon;
    double _RayonGauche;
    double _RayonDroit;
    QVector<CvPoint> _ListePoints;
    Analyzer* _Analyseur;
	Zor::Tools::ETAT_WEBCAM _WebcamState;      // Variable ou l'on stocke l'etat de la webcam
	QMutex _MutexState;

};
//
} // AAC
//
#endif // CONTROLLER
//
/********************************************************************************************************/
