/********************************************************************************************************/
/*
 Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frédéric (University of Science and Technology of Nantes)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef ETAT_H
#define ETAT_H

namespace AAC { namespace EE { class Etat; } }
/*
class Etat1;
class Etat2;
class Etat3;
*/
#include "../Controller.h"
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
#include "Events.h"
#include <algorithm>
#include <QTest>
#include <QTime>
#include <QVector>
//
namespace AAC {
namespace EE {
//
/**********************************************/
class Etat {

	public :
	// Destructeur
    virtual ~Etat() ;

	static bool _LeftDown;
	static bool _RightDown;

    // Les méthodes (virtuelles)
    virtual void execute(Controller * sender) = 0 ;
public slots:
    //
    void doubleClick();

	//virtual Etat * getInstance() = 0;
} ;//class Etat
/**********************************************/
// Etat correspondant a < 1 ou > 3 points
class Etat1 : public Etat {

		protected :
		// Constructeur
		Etat1() ;
		static Etat1 * _instance ;

		public :
		// Destructeur
		virtual ~Etat1() ;

		// Méthodes
		virtual void execute(Controller * sender);
		CvPoint calculCentre(Controller * sender);

		static Etat1 * getInstance() ;
};
/**********************************************/
// Etat correspondant a 2 points
class Etat2 : public Etat {

		protected :
		// Constructeur
		Etat2() ;
		static Etat2 * _instance;

		public :
		// Destructeur
		virtual ~Etat2() ;

		// Méthodes
		virtual void execute(Controller * sender) ;
		CvPoint calculCentre(Controller * sender) ;

		static Etat2 * getInstance() ;

};
/**********************************************/
// Etat correspondant a 3 points
class Etat3 : public Etat {

protected :

    //Constructeur
    Etat3() ;
    static Etat3 * _instance;

public :
    // Destructeur
    virtual ~Etat3() ;

    // Méthodes
    virtual void execute(Controller * sender) ;
    static Etat3 * getInstance() ;

private :
    void updateListePoints(const CvPoint& point);
    CvPoint moyenneListePoints();
    CvPoint calculCentre(Controller * sender) ;
    double calcul_rayon(Controller * sender) ;
    int rayon(Controller * sender ); // renvoie 0, 1, 2
    int maxPoints;
    QTime timeGauche;
    QTime timeDroit;
    CvPoint lastCenter;
    CvPoint actualCenter;
    QVector<CvPoint> listePoints;
    //
};//ETAT3

/**********************************************/
} // EE
} // AAC
#endif
//
/********************************************************************************************************/
