/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#ifndef OCVIMAGE_H
#define OCVIMAGE_H
//
/*************************************************************************/
//
// Inclusion des librairies
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif

//
/*************************************************************************/
//
template<class T> class Image
{
	private:
		//
  		IplImage* imgp;
		//
 	public:
		//
  		Image(IplImage* img=0) {imgp=img;}
  		~Image(){imgp=0;}
		//
  		void operator=(IplImage* img) {imgp=img;}
		//
  		inline T* operator[](const int rowIndx) {
    			return ((T *)(imgp->imageData + rowIndx*imgp->widthStep));}
};

// Structure
typedef struct{
	unsigned char b,g,r;
} RgbPixel;
//
typedef struct{
	float b,g,r;
} RgbPixelFloat;
typedef Image<RgbPixel>       	RgbImage;
typedef Image<RgbPixelFloat>  	RgbImageFloat;
typedef Image<unsigned char>  	BwImage;
typedef Image<float>          		BwImageFloat;
//
#endif // OCVIMAGE_H
//
/*************************************************************************/
