/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
//
#include "Display.h"
//
using namespace Zor::Tools;
//
namespace Zor{
//
/*************************************************************************/
// Constructeur de la classe (initialisation)
Display::Display(QWidget * parent): QWidget(parent) {
    this->setMouseTracking(true);               // Rcupration des vnements souris
	this->grabKeyboard();                       // Rcupration des vnements claviers
   _QImage=0;
   _DisplayQImage=0;
   rotationImage=NO_INVERSION;
}
//
/*************************************************************************/
// Destructeur de la classe
Display::~Display() {
    if(_QImage) delete(_QImage);
    if(_DisplayQImage) delete(_DisplayQImage);
}
//
/*************************************************************************/
//
void Display::switchRotation(){
    _Mutex.lock();                                              // Section critique ON
    rotationImage= (rotationImage==INVERSION) ? NO_INVERSION : INVERSION ;              // Rotation image
    _Mutex.unlock();                                            // Section critique OFF
}
//
/*************************************************************************/
//
void Display::updateQImage(IplImage * iplimage) {
    _Mutex.lock();                                              // Section critique ON
    if(_QImage) delete(_QImage);                                                        // Suppression de l'ancienne image intermdiaire
    if(_DisplayQImage) delete(_DisplayQImage);                                          // Suppression de l'ancienne image affiche
    _QImage = Divers::convertionIplImageQImage(iplimage,rotationImage);                 // Conversion de l'image sous format Qt
    _DisplayQImage = new QImage(_QImage->scaled(this->size(),Qt::IgnoreAspectRatio));   // Redimmensionnement pour l'affichage
    _Mutex.unlock();                                            // Section critique OFF
}
//
/*************************************************************************/
//
void Display::updateQImage(QImage * qimage) {
    _Mutex.lock();                                              // Section critique ON
    if(_QImage) delete(_QImage);                                                        // Suppression de l'ancienne image intermdiaire
    if(_DisplayQImage) delete(_DisplayQImage);                                          // Suppression de l'ancienne image affiche
    _QImage = new QImage(*qimage);                                                      // Sauvegarde de l'image sous format Qt
    _DisplayQImage = new QImage(_QImage->scaled(this->size(),Qt::IgnoreAspectRatio));   // Redimmensionnement pour l'affichage
    _Mutex.unlock();                                            // Section critique OFF
}
//
/*************************************************************************/
//
void Display::paintEvent( QPaintEvent * event ) {}
//
/*************************************************************************/
//
void Display::mousePressEvent(QMouseEvent *event) {}
//
/*************************************************************************/
//
void Display::mouseReleaseEvent(QMouseEvent *event){}
//
/*************************************************************************/
//
void Display::mouseMoveEvent(QMouseEvent *event){}
//
/*************************************************************************/
//
}
//
