/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
/*
Cette classe redfinit QDisplay et permet de slectionner des zones
*/
//
#ifndef DisplayCouleurs_H
#define DisplayCouleurs_H
//
// Librairies QT
#include <QtGui/QWidget>
#include <QPainter>
#include <QThread>
#include <QMouseEvent>
#include <QRectF>
#include <QMutex>
#include <QVector>
// Librairies OpenCV
#ifdef WIN32 // l'ordinateur est sous windows
#include <cv.h>
#include <highgui.h>
#else // Ordinateur sous autre chose que windows
#include <OpenCV/cv.h>
#include <OpenCV/highgui.h>
#endif  // endif
// Librairies Zor
#include "Tools.h"
#include "Display.h"
//
namespace Zor {
//
class DisplayCouleurs : public Display {
    //
	Q_OBJECT
	//
public:
    //
	DisplayCouleurs(QWidget * parent);
    ~DisplayCouleurs();
	//
	QVector<Zor::Tools::ZorRect*> _Element;         // Zones blanches
	void effaceElements();                          // Effacer toutes les zones
	//
protected:
    //
    void paintEvent( QPaintEvent * event );         // Rafraichissement des images du widget
	void mousePressEvent(QMouseEvent *event);       // Evnement souris (touche presse)
   	void mouseMoveEvent(QMouseEvent *event);        // Evnement souris (mouvement)
   	void mouseReleaseEvent(QMouseEvent *event);     // Evnement souris (touche relache)
    //
};
//
}
//
#endif // DisplayCouleurs_H
//
/********************************************************************************************************/

