/********************************************************************************************************/
/*
Copyright (C) 2008 Biger Kevin, Marguet Quentin, Muller Thomas, Vinatier Frdric (University of Science and Technology of Nantes)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Contact: glovecontrol@free.fr
*/
/********************************************************************************************************/
/* Notes (25/05/08)
La seconde heuristique n'est pas "stable" ni "optimis".
Correction : ajouter des try pour viter de planter sur une division par 0 et faire des tests pour ajuster les valeurs de l'heuristique.
L'algorithme ne possde pas de terminaison propre.
Correction : il y a diffrentes manires de faire terminer le programme (reboot, consenguinit...)
Bogue possible (pas sr que ca foire) c'est l'intersection des zones aprs redimmensionnement.
Correction : faire un test d'intersection sur les zones et soit quitter, soit faire un traitement de redimmensionnement.
*/
/********************************************************************************************************/
//
#include "Seuil.h"
//
using namespace blitz;
using namespace Zor::Tools;
//
namespace Zor{
//
/********************************************************************************************************/
//
Seuil::Seuil( DisplayCouleurs * display, const TYPE_HEURISTIQUE& heuristique):_Display(display),_Heuristique(heuristique) {
}
//
/********************************************************************************************************/
//
Seuil::~Seuil() {
}
//
/********************************************************************************************************/
//
void Seuil::run() {
    // Rcupration de l'image
    _QImage=_Display->_QImage;
    _ImageSeuil=QImage(*_QImage);

    // Initialisation de l'alatoire + variables de parcourt
    srand(time(NULL));
    int x,y,i,j,z;

    // Rcupration des informations et redimmensionnement des zones
    float ratio_X = float(_QImage->width())/float(_Display->width());
    float ratio_Y = float(_QImage->height())/float(_Display->height());


    // Creation des 4 zones + Remise  l'chelle des zones + Initialisation de variables
    int left, top, width, height;
    int zoneInt[4];
    QPoint rgb[3];
    int tailleImageZone[4];
    IplImage * imageZone[4];
    for(i=0; i < 3; i++){
        _Zone[i]=_Display->_Element.at(i)->rectangle();
        left = (int)(_Zone[i].left()*ratio_X);
        top = (int)(_Zone[i].top()*ratio_Y);
        width = (int)(_Zone[i].width()*ratio_X) > 1 ? (int)(_Zone[i].width()*ratio_X) : 1;
        height = (int)(_Zone[i].height()*ratio_Y) > 1 ? (int)(_Zone[i].height()*ratio_Y) : 1;
        _Zone[i].setRect(left, top, width, height);
        _Zone[i]=_Zone[i].normalized();
        tailleImageZone[i]=_Zone[i].height()*_Zone[i].width();
        imageZone[i] = cvCreateImage(cvSize( tailleImageZone[i],1), IPL_DEPTH_8U, 3);
        cvSet(imageZone[i],cvScalarAll(0),0);
        rgb[i]=QPoint(255,0);
        zoneInt[i]=0;
    }
    tailleImageZone[3]=_QImage->width()*_QImage->height()-(tailleImageZone[0]+tailleImageZone[1]+tailleImageZone[2]);
    imageZone[3] = cvCreateImage(cvSize(tailleImageZone[3],1), IPL_DEPTH_8U, 3);
    cvSet(imageZone[3],cvScalarAll(0),0);
    zoneInt[3]=0;

/*
    // Test zones disjointes  faire juste aprs le redimmensionnement et avant la cration des zones OpenCV
    // Apparement pas ncessaire
    bool intersected;
    for(i=0; i<3; i++){
        intersected=false;
        for(int j=0; j<3; j++){
            // Les zones entrent en collisions ?
            if(j!=i) { intersected=intersected || _Zone[i].intersects(_Zone[j]); }
            // Oui, quitter le programme avec un message ou redimmensionner les zones en enlever les parties communes
            if(intersected) {  }
            intersected=false;
        }
    }
*/

    // Optimisation des bornes du seuil, creation des zones (opration faites sur la QImage)
    bool zone[3];
    QColor couleur;
    unsigned char * image;
    for(y = 0; y < _QImage->height(); y++) { for(x = 0; x < _QImage->width(); x++) {
        couleur.setRgb(_QImage->pixel(x,y));
        if( (zone[0]=_Zone[0].contains(x,y)) || (zone[1]=_Zone[1].contains(x,y)) || (zone[2]=_Zone[2].contains(x,y)) ) {
            rgb[0].rx()= ( rgb[0].x() > couleur.red() ) ? couleur.red() : rgb[0].x();
            rgb[0].ry()= ( rgb[0].y() < couleur.red() ) ? couleur.red() : rgb[0].y();
            rgb[1].rx()= ( rgb[1].x() > couleur.green() ) ? couleur.green() : rgb[1].x();
            rgb[1].ry()= ( rgb[1].y() < couleur.green() ) ? couleur.green() : rgb[1].y();
            rgb[2].rx()= ( rgb[2].x() > couleur.blue() ) ? couleur.blue() : rgb[2].x();
            rgb[2].ry()= ( rgb[2].y() < couleur.blue() ) ? couleur.blue() : rgb[2].y();
            for(i = 0; i < 3; i++){
                if(zone[i]){
                    image = &((uchar*)(imageZone[i]->imageData))[zoneInt[i]*3];
                    image[2]=couleur.red();
                    image[1]=couleur.green();
                    image[0]=couleur.blue();
                    zoneInt[i]++;
                }
            }
        } else {
            image = &((uchar*)(imageZone[3]->imageData))[zoneInt[3]*3];
            image[2]=couleur.red();
            image[1]=couleur.green();
            image[0]=couleur.blue();
            zoneInt[3]++;
        }
    }}

    // Paramtre de l'algorithme gntique
    QPoint intervallePopulation, intervalleElite, intervalleMutation, intervalleCroisement;
    int populationTotale = 50;
    int populationElite = populationTotale*10/100;
    int populationMutee = populationTotale*30/100;
    int populationCroisee = populationTotale*60/100;
    int nombreIteration = 200;
    double pasProgression = 100.0/nombreIteration;

    // Calcul des intervalles de mutation
    QPoint intervalleOperation[3];
    for(i=0; i<3; i++){
        y = (rgb[i].y()-rgb[i].x())/5;
        x = -y;
        intervalleOperation[i] = QPoint(x,y);
    }

    // Cration des tableaux contenant les donnes
    Array<Individu,1> * tableauPopulation = new Array<Individu,1>(populationTotale);
    Array<Individu,1> * tableauIntermediaire = new Array<Individu,1>(populationTotale);
    Array<Individu,1> * tableauReference = 0;

    // Rcupration de l'intervalle contenant la population
    intervallePopulation = QPoint(0, populationTotale);
    intervalleElite = QPoint(0,populationElite);
    intervalleMutation = QPoint(populationElite,populationElite+populationMutee);
    intervalleCroisement = QPoint(populationElite+populationMutee,populationTotale);

    // Cration de la population de gne
    generePopulationAleatoire(*tableauPopulation, intervallePopulation, rgb);

    // Boucle de l'algorithme genetique
    i = 0;
    Individu * seuil;
    IplImage * ilpimage;
    double zoneFloat[4];
    while(i < nombreIteration){
        j= (i==0) ? j = 0 : populationElite;
        while(j < populationTotale){
            // Rcupration du individu
            seuil = &(*tableauPopulation)(j);

            // Calcul du nombre de gnes prsent dans les zones
            for(x = 0; x < 4; x++){
                ilpimage = cvCreateImage(cvGetSize(imageZone[x]), IPL_DEPTH_8U, 1);
                cvInRangeS(imageZone[x],CV_RGB(seuil->rgb[0].x(),seuil->rgb[1].x(),seuil->rgb[2].x()),CV_RGB(seuil->rgb[0].y()+1,seuil->rgb[1].y()+1,seuil->rgb[2].y()+1),ilpimage);
                zoneFloat[x]=cvCountNonZero(ilpimage);
                cvReleaseImage(&ilpimage);
            }

            // Calcul de l'heuristique
            switch(_Heuristique){
                case HEU_0:
                    seuil->valeur=(zoneFloat[0]+zoneFloat[1]+zoneFloat[2])/(zoneFloat[3]+1);
                break;
                case HEU_1:
                    seuil->valeur=(zoneFloat[0]+zoneFloat[1]+zoneFloat[2])/(zoneFloat[3]+1) * (1.0/ sqrt(1.0/3.0*(pow(double(zoneFloat[0]/tailleImageZone[0]),2.0)+pow(double(zoneFloat[1]/tailleImageZone[1]),2.0)+pow(double(zoneFloat[2]/tailleImageZone[2]),2)) - pow(double(1.0/3.0*(zoneFloat[0]/tailleImageZone[0]+zoneFloat[1]/tailleImageZone[1]+zoneFloat[2]/tailleImageZone[2])),2.0)));
                    // Cette comparaison vite les nombres impossibles => Not a Number
                    if(seuil->valeur!=seuil->valeur){
                        seuil->valeur=0;
                    }
                break;
                default:
                break;
            }

            // Incrmentation du compteur de boucle
            j++;
        }

        // Tri des donnes
        Divers::triRapide(*tableauPopulation, intervallePopulation);

        // Affichage
        //affichage(*tableauPopulation, intervallePopulation);

        i++;
        emit rafraichitProgression((int) (pasProgression*i) );
        if(nombreIteration!=i){

            // Sauvegarde des elites
            elite(*tableauPopulation, *tableauIntermediaire, intervalleElite);

            // Mutation d'une partie de la population
            mutation(*tableauPopulation, *tableauIntermediaire, intervallePopulation, intervalleMutation, intervalleOperation, rgb);

            // Croisement d'une partie de la population
            croisement(*tableauPopulation, *tableauIntermediaire, intervallePopulation, intervalleCroisement, rgb);

            // Permutation des tableaux
            tableauReference = tableauPopulation;
            tableauPopulation = tableauIntermediaire;
            tableauIntermediaire = tableauReference;
        }
    }
    // Sauvegarde du meilleur gne
    _Individu=(*tableauPopulation)(0);

    // Cration de l'image seuill
    genereImageSeuil((*tableauPopulation)(0));

    // Le calcul est termin
    emit calculTermine();
}
//
/*************************************************************************/
//
void Seuil::generePopulationAleatoire(Array<Individu,1>& tableauEntree, const QPoint& zoneEntree, const QPoint intervalleRGB[]) {
    QPoint aleatoire;   // Bornes alatoires infrieures et suprieures
    for(int i = zoneEntree.x(); i < zoneEntree.y(); i++) {  // Parcourt du tableau dans la zone en paramtre
        for(int j = 0; j < 3; j++) {    // Parcourt des trois composantes de couleurs
            aleatoire.rx() = Divers::aleatoire(intervalleRGB[j].x(), intervalleRGB[j].y()); // Rcupration d'une borne
            aleatoire.ry() = Divers::aleatoire(intervalleRGB[j].x(), intervalleRGB[j].y()); // Rcupration d'une autre borne
            tableauEntree(i).rgb[j] = ( aleatoire.x()<aleatoire.y() ) ? QPoint(aleatoire.x(), aleatoire.y()) : QPoint(aleatoire.y(), aleatoire.x()); // Stockage de la borne infrieure et suprieure
        }
        tableauEntree(i).valeur = 0.0;  // Valeur du gne
        tableauEntree(i).etat = NORMAL; // Etat du gne
    }
}
//
/*************************************************************************/
//
void Seuil::elite(Array<Individu,1>& tableauEntree, Array<Individu,1>& tableauSortie, const QPoint& zoneSortie){
    for(int i = zoneSortie.x(); i < zoneSortie.y(); i++){
        tableauSortie(i) = tableauEntree(i);
        tableauSortie(i).etat = ELITE;
    }

    //tableauSortie(Range(zone.x(),zone.y()))=tableauEntree(Range(zone.x(),zone.y()));
}
//
/*************************************************************************/
//
void Seuil::mutation(Array<Individu,1>& tableauEntree, Array<Individu,1>& tableauSortie, const QPoint& zoneEntree, const QPoint& zoneSortie, const QPoint zoneAleatoire[], const QPoint intervalleRGB[]){
    QPoint aleatoire;   // Bornes alatoires infrieures et suprieures
    int individuAleatoire;  // Numro du gne alatoire slctionn

    for(int i = zoneSortie.x(); i < zoneSortie.y(); i++){ // Parcourt du tableau de sortie avec la zone en paramtre
        individuAleatoire = Divers::aleatoire(zoneEntree.x(), zoneEntree.y());    // Acquisition d'un individu alatoire
        for(int j = 0; j < 3; j++){  // Parcourt des trois composantes de couleurs
            aleatoire.rx() = Divers::aleatoire(zoneAleatoire[j].x(), zoneAleatoire[j].y());   // Gnration d'une valeur alatoire (borne infrieure)
            aleatoire.ry() = Divers::aleatoire(zoneAleatoire[j].x(), zoneAleatoire[j].y());   // Gnration d'une valeur alatoire (borne suprieure)

            tableauSortie(i).rgb[j].rx() = tableauEntree(individuAleatoire).rgb[j].x() + aleatoire.x(); // Stockage d'une borne d'une composante du gne dans le tableau de sortie + mutation
            // Technique du rebond (il faut rester dans l'intervalle admissible)
            if(tableauSortie(i).rgb[j].x()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].x(); } else
            if(tableauSortie(i).rgb[j].x()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].x(); }

            tableauSortie(i).rgb[j].ry() = tableauEntree(individuAleatoire).rgb[j].y() + aleatoire.y(); // Stockage d'une borne d'une composante du gne dans le tableau de sortie + mutation
            // Technique du rebond (il faut rester dans l'intervalle admissible)
            if(tableauSortie(i).rgb[j].y()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].y(); } else
            if(tableauSortie(i).rgb[j].y()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].y(); }

            // Permutation des bornes ?
            if( tableauSortie(i).rgb[j].x()>tableauSortie(i).rgb[j].y() ){ tableauSortie(i).rgb[j] =  QPoint(tableauSortie(i).rgb[j].y(), tableauSortie(i).rgb[j].x()); }

            /*
            if( (tableauSortie(i).rgb[j].x()<0) || (tableauSortie(i).rgb[j].y()<0) ){
                std::cout << "Individu aleatoire : " << individuAleatoire << std::endl;
                std::cout << "intervalle RGB : " << intervalleRGB[j].x() << "   " << intervalleRGB[j].y() << std::endl;
                std::cout << "ZoneAleatoire : " << zoneAleatoire[j].x() << "   " << zoneAleatoire[j].y() << std::endl;
                std::cout << "Aleatoire : " << aleatoire.x() << "   " << aleatoire.y() << std::endl;
                std::cout << "RGB : " << tableauEntree(individuAleatoire).rgb[j].x() << "   " << tableauEntree(individuAleatoire).rgb[j].y() << std::endl;
                std::cout << "RGB : " << tableauSortie(i).rgb[j].x() << "   " << tableauSortie(i).rgb[j].y() << std::endl;
                std::cout << "ERREUR mutation" << std::endl;
                QTest::qSleep(4000);
            }
            */

        }

        tableauSortie(i).valeur = 0.0;  // Valeur du gne
        tableauSortie(i).etat = MUTEE;  // Etat du gne
    }
}
//
/*************************************************************************/
//
void Seuil::croisement(Array<Individu,1>& tableauEntree, Array<Individu,1>& tableauSortie, const QPoint& zoneEntree, const QPoint& zoneSortie, const QPoint intervalleRGB[]){
    int individuAleatoire1, individuAleatoire2;   // Dclaration des variables permettant de rcuperer les individus
    float a = 1.2;  // Le nombre magique
    for(int i = zoneSortie.x(); i < zoneSortie.y(); i++) { // Parcourt du tableau de sortie avec la zone en paramtre
        individuAleatoire1 = Divers::aleatoire(zoneEntree.x(), zoneEntree.y());   // Acquisition d'un gne alatoire
        individuAleatoire2 = Divers::aleatoire(zoneEntree.x(), zoneEntree.y());   // Acquisition d'un second gne alatoire
        if(tableauEntree(individuAleatoire1).valeur>tableauEntree(individuAleatoire2).valeur){  // Croisement selon la qualit du gne
            for(int j = 0; j < 3; j++){ // Parcourt des trois composantes de couleurs
                // Croisement de la borne infrieure
                tableauSortie(i).rgb[j].rx() = (int)(tableauEntree(individuAleatoire1).rgb[j].x()*a + tableauEntree(individuAleatoire2).rgb[j].x()*(1-a));
                if(tableauSortie(i).rgb[j].x()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].x(); } else
                if(tableauSortie(i).rgb[j].x()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].x(); }
                // Croisement de la borne suprieure
                tableauSortie(i).rgb[j].ry() = (int)(tableauEntree(individuAleatoire1).rgb[j].y()*a + tableauEntree(individuAleatoire2).rgb[j].y()*(1-a));
                if(tableauSortie(i).rgb[j].y()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].y(); } else
                if(tableauSortie(i).rgb[j].y()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].y(); }
                // Permutation des bornes ?
                if( tableauSortie(i).rgb[j].x()>tableauSortie(i).rgb[j].y() ){ tableauSortie(i).rgb[j] =  QPoint(tableauSortie(i).rgb[j].y(), tableauSortie(i).rgb[j].x()); }
            }
        } else {
            for(int j = 0; j < 3; j++){
                tableauSortie(i).rgb[j].rx() = (int)(tableauEntree(individuAleatoire2).rgb[j].x()*a + tableauEntree(individuAleatoire1).rgb[j].x()*(1-a));
                if(tableauSortie(i).rgb[j].x()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].x(); } else
                if(tableauSortie(i).rgb[j].x()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].rx()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].x(); }
                tableauSortie(i).rgb[j].ry() = (int)(tableauEntree(individuAleatoire2).rgb[j].y()*a + tableauEntree(individuAleatoire1).rgb[j].y()*(1-a));
                if(tableauSortie(i).rgb[j].y()>intervalleRGB[j].y()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].y()*2-tableauSortie(i).rgb[j].y(); } else
                if(tableauSortie(i).rgb[j].y()<intervalleRGB[j].x()) { tableauSortie(i).rgb[j].ry()=intervalleRGB[j].x()*2-tableauSortie(i).rgb[j].y(); }
                // Permutation des bornes ?
                if( tableauSortie(i).rgb[j].x()>tableauSortie(i).rgb[j].y() ){ tableauSortie(i).rgb[j] =  QPoint(tableauSortie(i).rgb[j].y(), tableauSortie(i).rgb[j].x()); }
            }
        }

        tableauSortie(i).valeur = 0.0;  // Valeur du gne
        tableauSortie(i).etat = CROISEE; // Etat du gne
    }
}
//
/*************************************************************************/
//
void Seuil::affichage(Array<Individu,1>& tableauEntree, const QPoint& zoneEntree){

    for(int i =  zoneEntree.y()-1; i >= zoneEntree.x(); i--){
        std::cout << "**************************" << std::endl;
        std::cout << "Numero du individu dans le tableau : " << i << std::endl;
        std::cout << "RGB rouge : (" << tableauEntree(i).rgb[0].x() << ", " << tableauEntree(i).rgb[0].y() << ")" << std::endl;
        std::cout << "RGB vert : (" << tableauEntree(i).rgb[1].x() << ", " << tableauEntree(i).rgb[1].y() << ")" << std::endl;
        std::cout << "RGB bleu : (" << tableauEntree(i).rgb[2].x() << ", " << tableauEntree(i).rgb[2].y() << ")" << std::endl;
        std::cout << "Valeur calculee : " << tableauEntree(i).valeur << std::endl;
        std::cout << "**************************" << std::endl;
        /*
        for(int j=0; j<3; j++){
            if( (tableauEntree(i).rgb[j].x()<0) || (tableauEntree(i).rgb[j].y()>255) ){
                std::cout << "RGB : " << tableauEntree(i).rgb[j].x() << "   " << tableauEntree(i).rgb[j].y() << std::endl;
                std::cout << "ERREUR tri" << std::endl;
                QTest::qSleep(4000);
            }
        }
        */
    }
}
//
/*************************************************************************/
//
void Seuil::genereImageSeuil(const Individu& seuil){
    QColor pixel;
    for(int y = 0; y < _ImageSeuil.height(); y++) { for(int x = 0; x < _ImageSeuil.width(); x++) {
        pixel = _ImageSeuil.pixel(x,y);
        if(!Divers::dansSeuil(pixel,seuil)) {
            QColor color(0,0,0);
            _ImageSeuil.setPixel(x,y,color.rgb());
        } else {
            QColor color(255,255,255);
            _ImageSeuil.setPixel(x,y,color.rgb());
        }
     }}
}
//
/*************************************************************************/
//
}
//
